org.apache.lucene.search

## Class DocValuesStats.NumericDocValuesStats<T extends Number>

- java.lang.Object
- - org.apache.lucene.search.DocValuesStats<T>
  - - org.apache.lucene.search.DocValuesStats.NumericDocValuesStats<T>

Direct Known Subclasses:
  DocValuesStats.DoubleDocValuesStats, DocValuesStats.LongDocValuesStats

Enclosing class:
  DocValuesStats<T>

    public abstract static class DocValuesStats.NumericDocValuesStats<T extends Number>
    extends DocValuesStats<T>

Holds statistics for a numeric DocValues field.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.lucene.search.DocValuesStats

`DocValuesStats.DoubleDocValuesStats, DocValuesStats.LongDocValuesStats, DocValuesStats.NumericDocValuesStats<T extends Number>, DocValuesStats.SortedDocValuesStats, DocValuesStats.SortedDoubleDocValuesStats, DocValuesStats.SortedLongDocValuesStats, DocValuesStats.SortedNumericDocValuesStats<T extends Number>, DocValuesStats.SortedSetDocValuesStats`

### Field Summary

Fields
`protected double` `mean`
`protected NumericDocValues` `ndv`
`protected double` `variance`

### Fields inherited from class org.apache.lucene.search.DocValuesStats

`field, max, min`

### Constructor Summary

Constructors
`protected` `NumericDocValuesStats(String field, T initialMin, T initialMax)`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`protected boolean` `hasValue(int doc)` Returns whether the given document has a value for the requested DocValues field.
`protected boolean` `init(LeafReaderContext context)` Initializes this object with the given reader context.
`double` `mean()` The mean of all values of the field.
`double` `stdev()` Returns the stdev of all values of the field.
`abstract T` `sum()` Returns the sum of values of the field.
`double` `variance()` Returns the variance of all values of the field.

### Methods inherited from class org.apache.lucene.search.DocValuesStats

`count, doAccumulate, field, max, min, missing`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### mean

    protected double mean

#### variance

    protected double variance

#### ndv

    protected NumericDocValues ndv

### Constructor Detail

#### NumericDocValuesStats

    protected NumericDocValuesStats(String field,
                                    T initialMin,
                                    T initialMax)

### Method Detail

#### init

    protected final boolean init(LeafReaderContext context)
                          throws IOException

Description copied from class: `DocValuesStats`
Initializes this object with the given reader context. Returns whether stats can be computed for this segment (i.e. it does have the requested DocValues field).

Specified by:
  `init` in class `DocValuesStats<T extends Number>`
Throws:
  `IOException`

#### hasValue

    protected final boolean hasValue(int doc)
                              throws IOException

Description copied from class: `DocValuesStats`
Returns whether the given document has a value for the requested DocValues field.

Specified by:
  `hasValue` in class `DocValuesStats<T extends Number>`
Throws:
  `IOException`

#### mean

    public final double mean()

The mean of all values of the field.

#### variance

    public final double variance()

Returns the variance of all values of the field.

#### stdev

    public final double stdev()

Returns the stdev of all values of the field.

#### sum

    public abstract T sum()

Returns the sum of values of the field. Note that if the values are large, the `sum` might overflow.